// Code generated by client-gen. DO NOT EDIT.

package v1

import (
	"context"
	"time"

	v1 "github.com/superedge/superedge/pkg/application-grid-controller/apis/superedge.io/v1"
	scheme "github.com/superedge/superedge/pkg/application-grid-controller/generated/clientset/versioned/scheme"
	metav1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	rest "k8s.io/client-go/rest"
)

// StatefulSetGridsGetter has a method to return a StatefulSetGridInterface.
// A group's client should implement this interface.
type StatefulSetGridsGetter interface {
	StatefulSetGrids(namespace string) StatefulSetGridInterface
}

// StatefulSetGridInterface has methods to work with StatefulSetGrid resources.
type StatefulSetGridInterface interface {
	Create(ctx context.Context, statefulSetGrid *v1.StatefulSetGrid, opts metav1.CreateOptions) (*v1.StatefulSetGrid, error)
	Update(ctx context.Context, statefulSetGrid *v1.StatefulSetGrid, opts metav1.UpdateOptions) (*v1.StatefulSetGrid, error)
	UpdateStatus(ctx context.Context, statefulSetGrid *v1.StatefulSetGrid, opts metav1.UpdateOptions) (*v1.StatefulSetGrid, error)
	Delete(ctx context.Context, name string, opts metav1.DeleteOptions) error
	DeleteCollection(ctx context.Context, opts metav1.DeleteOptions, listOpts metav1.ListOptions) error
	Get(ctx context.Context, name string, opts metav1.GetOptions) (*v1.StatefulSetGrid, error)
	List(ctx context.Context, opts metav1.ListOptions) (*v1.StatefulSetGridList, error)
	Watch(ctx context.Context, opts metav1.ListOptions) (watch.Interface, error)
	Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts metav1.PatchOptions, subresources ...string) (result *v1.StatefulSetGrid, err error)
	StatefulSetGridExpansion
}

// statefulSetGrids implements StatefulSetGridInterface
type statefulSetGrids struct {
	client rest.Interface
	ns     string
}

// newStatefulSetGrids returns a StatefulSetGrids
func newStatefulSetGrids(c *SuperedgeV1Client, namespace string) *statefulSetGrids {
	return &statefulSetGrids{
		client: c.RESTClient(),
		ns:     namespace,
	}
}

// Get takes name of the statefulSetGrid, and returns the corresponding statefulSetGrid object, and an error if there is any.
func (c *statefulSetGrids) Get(ctx context.Context, name string, options metav1.GetOptions) (result *v1.StatefulSetGrid, err error) {
	result = &v1.StatefulSetGrid{}
	err = c.client.Get().
		Namespace(c.ns).
		Resource("statefulsetgrids").
		Name(name).
		VersionedParams(&options, scheme.ParameterCodec).
		Do(ctx).
		Into(result)
	return
}

// List takes label and field selectors, and returns the list of StatefulSetGrids that match those selectors.
func (c *statefulSetGrids) List(ctx context.Context, opts metav1.ListOptions) (result *v1.StatefulSetGridList, err error) {
	var timeout time.Duration
	if opts.TimeoutSeconds != nil {
		timeout = time.Duration(*opts.TimeoutSeconds) * time.Second
	}
	result = &v1.StatefulSetGridList{}
	err = c.client.Get().
		Namespace(c.ns).
		Resource("statefulsetgrids").
		VersionedParams(&opts, scheme.ParameterCodec).
		Timeout(timeout).
		Do(ctx).
		Into(result)
	return
}

// Watch returns a watch.Interface that watches the requested statefulSetGrids.
func (c *statefulSetGrids) Watch(ctx context.Context, opts metav1.ListOptions) (watch.Interface, error) {
	var timeout time.Duration
	if opts.TimeoutSeconds != nil {
		timeout = time.Duration(*opts.TimeoutSeconds) * time.Second
	}
	opts.Watch = true
	return c.client.Get().
		Namespace(c.ns).
		Resource("statefulsetgrids").
		VersionedParams(&opts, scheme.ParameterCodec).
		Timeout(timeout).
		Watch(ctx)
}

// Create takes the representation of a statefulSetGrid and creates it.  Returns the server's representation of the statefulSetGrid, and an error, if there is any.
func (c *statefulSetGrids) Create(ctx context.Context, statefulSetGrid *v1.StatefulSetGrid, opts metav1.CreateOptions) (result *v1.StatefulSetGrid, err error) {
	result = &v1.StatefulSetGrid{}
	err = c.client.Post().
		Namespace(c.ns).
		Resource("statefulsetgrids").
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(statefulSetGrid).
		Do(ctx).
		Into(result)
	return
}

// Update takes the representation of a statefulSetGrid and updates it. Returns the server's representation of the statefulSetGrid, and an error, if there is any.
func (c *statefulSetGrids) Update(ctx context.Context, statefulSetGrid *v1.StatefulSetGrid, opts metav1.UpdateOptions) (result *v1.StatefulSetGrid, err error) {
	result = &v1.StatefulSetGrid{}
	err = c.client.Put().
		Namespace(c.ns).
		Resource("statefulsetgrids").
		Name(statefulSetGrid.Name).
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(statefulSetGrid).
		Do(ctx).
		Into(result)
	return
}

// UpdateStatus was generated because the type contains a Status member.
// Add a +genclient:noStatus comment above the type to avoid generating UpdateStatus().
func (c *statefulSetGrids) UpdateStatus(ctx context.Context, statefulSetGrid *v1.StatefulSetGrid, opts metav1.UpdateOptions) (result *v1.StatefulSetGrid, err error) {
	result = &v1.StatefulSetGrid{}
	err = c.client.Put().
		Namespace(c.ns).
		Resource("statefulsetgrids").
		Name(statefulSetGrid.Name).
		SubResource("status").
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(statefulSetGrid).
		Do(ctx).
		Into(result)
	return
}

// Delete takes name of the statefulSetGrid and deletes it. Returns an error if one occurs.
func (c *statefulSetGrids) Delete(ctx context.Context, name string, opts metav1.DeleteOptions) error {
	return c.client.Delete().
		Namespace(c.ns).
		Resource("statefulsetgrids").
		Name(name).
		Body(&opts).
		Do(ctx).
		Error()
}

// DeleteCollection deletes a collection of objects.
func (c *statefulSetGrids) DeleteCollection(ctx context.Context, opts metav1.DeleteOptions, listOpts metav1.ListOptions) error {
	var timeout time.Duration
	if listOpts.TimeoutSeconds != nil {
		timeout = time.Duration(*listOpts.TimeoutSeconds) * time.Second
	}
	return c.client.Delete().
		Namespace(c.ns).
		Resource("statefulsetgrids").
		VersionedParams(&listOpts, scheme.ParameterCodec).
		Timeout(timeout).
		Body(&opts).
		Do(ctx).
		Error()
}

// Patch applies the patch and returns the patched statefulSetGrid.
func (c *statefulSetGrids) Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts metav1.PatchOptions, subresources ...string) (result *v1.StatefulSetGrid, err error) {
	result = &v1.StatefulSetGrid{}
	err = c.client.Patch(pt).
		Namespace(c.ns).
		Resource("statefulsetgrids").
		Name(name).
		SubResource(subresources...).
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(data).
		Do(ctx).
		Into(result)
	return
}
