// Code generated by informer-gen. DO NOT EDIT.

package v1

import (
	"context"
	time "time"

	superedgeiov1 "github.com/superedge/superedge/pkg/application-grid-controller/apis/superedge.io/v1"
	versioned "github.com/superedge/superedge/pkg/application-grid-controller/generated/clientset/versioned"
	internalinterfaces "github.com/superedge/superedge/pkg/application-grid-controller/generated/informers/externalversions/internalinterfaces"
	v1 "github.com/superedge/superedge/pkg/application-grid-controller/generated/listers/superedge.io/v1"
	metav1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	runtime "k8s.io/apimachinery/pkg/runtime"
	watch "k8s.io/apimachinery/pkg/watch"
	cache "k8s.io/client-go/tools/cache"
)

// StatefulSetGridInformer provides access to a shared informer and lister for
// StatefulSetGrids.
type StatefulSetGridInformer interface {
	Informer() cache.SharedIndexInformer
	Lister() v1.StatefulSetGridLister
}

type statefulSetGridInformer struct {
	factory          internalinterfaces.SharedInformerFactory
	tweakListOptions internalinterfaces.TweakListOptionsFunc
	namespace        string
}

// NewStatefulSetGridInformer constructs a new informer for StatefulSetGrid type.
// Always prefer using an informer factory to get a shared informer instead of getting an independent
// one. This reduces memory footprint and number of connections to the server.
func NewStatefulSetGridInformer(client versioned.Interface, namespace string, resyncPeriod time.Duration, indexers cache.Indexers) cache.SharedIndexInformer {
	return NewFilteredStatefulSetGridInformer(client, namespace, resyncPeriod, indexers, nil)
}

// NewFilteredStatefulSetGridInformer constructs a new informer for StatefulSetGrid type.
// Always prefer using an informer factory to get a shared informer instead of getting an independent
// one. This reduces memory footprint and number of connections to the server.
func NewFilteredStatefulSetGridInformer(client versioned.Interface, namespace string, resyncPeriod time.Duration, indexers cache.Indexers, tweakListOptions internalinterfaces.TweakListOptionsFunc) cache.SharedIndexInformer {
	return cache.NewSharedIndexInformer(
		&cache.ListWatch{
			ListFunc: func(options metav1.ListOptions) (runtime.Object, error) {
				if tweakListOptions != nil {
					tweakListOptions(&options)
				}
				return client.SuperedgeV1().StatefulSetGrids(namespace).List(context.TODO(), options)
			},
			WatchFunc: func(options metav1.ListOptions) (watch.Interface, error) {
				if tweakListOptions != nil {
					tweakListOptions(&options)
				}
				return client.SuperedgeV1().StatefulSetGrids(namespace).Watch(context.TODO(), options)
			},
		},
		&superedgeiov1.StatefulSetGrid{},
		resyncPeriod,
		indexers,
	)
}

func (f *statefulSetGridInformer) defaultInformer(client versioned.Interface, resyncPeriod time.Duration) cache.SharedIndexInformer {
	return NewFilteredStatefulSetGridInformer(client, f.namespace, resyncPeriod, cache.Indexers{cache.NamespaceIndex: cache.MetaNamespaceIndexFunc}, f.tweakListOptions)
}

func (f *statefulSetGridInformer) Informer() cache.SharedIndexInformer {
	return f.factory.InformerFor(&superedgeiov1.StatefulSetGrid{}, f.defaultInformer)
}

func (f *statefulSetGridInformer) Lister() v1.StatefulSetGridLister {
	return v1.NewStatefulSetGridLister(f.Informer().GetIndexer())
}
